Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/CheckedTransformationListView.cs	(revision 15535)
@@ -51,5 +51,5 @@
           // TODO: Avoid accessing parent view
           var transformationView = (TransformationView)Parent;
-          var columnNames = transformationView.Content.Data.VariableNames;
+          var columnNames = transformationView.Content.PreprocessingData.VariableNames;
 
           return (ITransformation)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType(new[] { columnNames });
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataCompletenessView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataCompletenessView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataCompletenessView.cs	(revision 15535)
@@ -52,11 +52,8 @@
 
     private void InitData() {
-      IDictionary<int, IList<int>> missingValueIndices = Content.SearchLogic.GetMissingValueIndices();
-
-      bool[,] valueMissing = new bool[Content.SearchLogic.Rows, Content.SearchLogic.Columns];
-      foreach (var columnMissingValues in missingValueIndices) {
-        var column = columnMissingValues.Key;
-        foreach (var missingValueIndex in columnMissingValues.Value)
-          valueMissing[missingValueIndex, column] = true;
+      bool[,] valueMissing = new bool[Content.PreprocessingData.Rows, Content.PreprocessingData.Columns];
+      for (int row = 0; row < Content.PreprocessingData.Rows; row++) {
+        for (int column = 0; column < Content.PreprocessingData.Columns; column++)
+          valueMissing[row, column] = Content.PreprocessingData.IsCellEmpty(column, row);
       }
 
@@ -78,5 +75,5 @@
       //custom x axis label
       double from = 0.5;
-      foreach (String columnName in Content.SearchLogic.VariableNames) {
+      foreach (String columnName in Content.PreprocessingData.VariableNames) {
         double to = from + 1;
         chart.ChartAreas[0].AxisX.CustomLabels.Add(from, to, columnName);
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 15535)
@@ -54,5 +54,4 @@
       this.mostCommonToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
       this.interpolationToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
-      this.smoothingToolStripMenuItem_Column = new System.Windows.Forms.ToolStripMenuItem();
       this.replaceValueOverSelectionToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.averageToolStripMenuItem_Selection = new System.Windows.Forms.ToolStripMenuItem();
@@ -63,11 +62,13 @@
       this.btnReplace = new System.Windows.Forms.Button();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.checkInputsTargetButton = new System.Windows.Forms.Button();
-      this.uncheckAllButton = new System.Windows.Forms.Button();
-      this.checkAllButton = new System.Windows.Forms.Button();
+      this.shuffleWithinPartitionsCheckBox = new System.Windows.Forms.CheckBox();
       this.addRowButton = new System.Windows.Forms.Button();
       this.addColumnButton = new System.Windows.Forms.Button();
       this.renameColumnsButton = new System.Windows.Forms.Button();
       this.showVariablesGroupBox = new System.Windows.Forms.GroupBox();
+      this.shuffleAllButton = new System.Windows.Forms.Button();
+      this.checkInputsTargetButton = new System.Windows.Forms.Button();
+      this.uncheckAllButton = new System.Windows.Forms.Button();
+      this.checkAllButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.contextMenuCell.SuspendLayout();
@@ -127,6 +128,5 @@
             this.randomToolStripMenuItem_Column,
             this.mostCommonToolStripMenuItem_Column,
-            this.interpolationToolStripMenuItem_Column,
-            this.smoothingToolStripMenuItem_Column});
+            this.interpolationToolStripMenuItem_Column});
       this.replaceValueOverColumnToolStripMenuItem.Name = "replaceValueOverColumnToolStripMenuItem";
       this.replaceValueOverColumnToolStripMenuItem.Size = new System.Drawing.Size(223, 22);
@@ -167,11 +167,4 @@
       this.interpolationToolStripMenuItem_Column.Text = "Interpolation";
       this.interpolationToolStripMenuItem_Column.Click += new System.EventHandler(this.ReplaceWithInterpolation_Column_Click);
-      // 
-      // smoothingToolStripMenuItem_Column
-      // 
-      this.smoothingToolStripMenuItem_Column.Name = "smoothingToolStripMenuItem_Column";
-      this.smoothingToolStripMenuItem_Column.Size = new System.Drawing.Size(155, 22);
-      this.smoothingToolStripMenuItem_Column.Text = "Smoothing";
-      this.smoothingToolStripMenuItem_Column.Click += new System.EventHandler(this.ReplaceWithSmoothing_Selection_Click);
       // 
       // replaceValueOverSelectionToolStripMenuItem
@@ -236,4 +229,68 @@
       this.btnReplace.Click += new System.EventHandler(this.btnReplace_Click);
       // 
+      // shuffleWithinPartitionsCheckBox
+      // 
+      this.shuffleWithinPartitionsCheckBox.AutoSize = true;
+      this.shuffleWithinPartitionsCheckBox.Location = new System.Drawing.Point(444, 30);
+      this.shuffleWithinPartitionsCheckBox.Name = "shuffleWithinPartitionsCheckBox";
+      this.shuffleWithinPartitionsCheckBox.Size = new System.Drawing.Size(102, 17);
+      this.shuffleWithinPartitionsCheckBox.TabIndex = 20;
+      this.shuffleWithinPartitionsCheckBox.Text = "Within Partitions";
+      this.toolTip.SetToolTip(this.shuffleWithinPartitionsCheckBox, "If checked, the Training and Test partitions are shuffled separately. Otherwise a" +
+        "ll data is shuffled.");
+      this.shuffleWithinPartitionsCheckBox.UseVisualStyleBackColor = true;
+      // 
+      // addRowButton
+      // 
+      this.addRowButton.Location = new System.Drawing.Point(338, 26);
+      this.addRowButton.Name = "addRowButton";
+      this.addRowButton.Size = new System.Drawing.Size(83, 23);
+      this.addRowButton.TabIndex = 10;
+      this.addRowButton.Text = "Add Datarow";
+      this.addRowButton.UseVisualStyleBackColor = true;
+      this.addRowButton.Click += new System.EventHandler(this.addRowButton_Click);
+      // 
+      // addColumnButton
+      // 
+      this.addColumnButton.Location = new System.Drawing.Point(338, 0);
+      this.addColumnButton.Name = "addColumnButton";
+      this.addColumnButton.Size = new System.Drawing.Size(83, 23);
+      this.addColumnButton.TabIndex = 10;
+      this.addColumnButton.Text = "Add Variable";
+      this.addColumnButton.UseVisualStyleBackColor = true;
+      this.addColumnButton.Click += new System.EventHandler(this.addColumnButton_Click);
+      // 
+      // renameColumnsButton
+      // 
+      this.renameColumnsButton.Location = new System.Drawing.Point(228, 26);
+      this.renameColumnsButton.Name = "renameColumnsButton";
+      this.renameColumnsButton.Size = new System.Drawing.Size(104, 23);
+      this.renameColumnsButton.TabIndex = 11;
+      this.renameColumnsButton.Text = "Rename Variables";
+      this.renameColumnsButton.UseVisualStyleBackColor = true;
+      this.renameColumnsButton.Click += new System.EventHandler(this.renameColumnsButton_Click);
+      // 
+      // showVariablesGroupBox
+      // 
+      this.showVariablesGroupBox.Controls.Add(this.checkInputsTargetButton);
+      this.showVariablesGroupBox.Controls.Add(this.uncheckAllButton);
+      this.showVariablesGroupBox.Controls.Add(this.checkAllButton);
+      this.showVariablesGroupBox.Location = new System.Drawing.Point(564, 0);
+      this.showVariablesGroupBox.Name = "showVariablesGroupBox";
+      this.showVariablesGroupBox.Size = new System.Drawing.Size(97, 49);
+      this.showVariablesGroupBox.TabIndex = 17;
+      this.showVariablesGroupBox.TabStop = false;
+      this.showVariablesGroupBox.Text = "Show Variables";
+      // 
+      // shuffleAllButton
+      // 
+      this.shuffleAllButton.Location = new System.Drawing.Point(444, 0);
+      this.shuffleAllButton.Name = "shuffleAllButton";
+      this.shuffleAllButton.Size = new System.Drawing.Size(102, 23);
+      this.shuffleAllButton.TabIndex = 19;
+      this.shuffleAllButton.Text = "Shuffle";
+      this.shuffleAllButton.UseVisualStyleBackColor = true;
+      this.shuffleAllButton.Click += new System.EventHandler(this.shuffleAllButton_Click);
+      // 
       // checkInputsTargetButton
       // 
@@ -269,50 +326,10 @@
       this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
       // 
-      // addRowButton
-      // 
-      this.addRowButton.Location = new System.Drawing.Point(338, 26);
-      this.addRowButton.Name = "addRowButton";
-      this.addRowButton.Size = new System.Drawing.Size(83, 23);
-      this.addRowButton.TabIndex = 10;
-      this.addRowButton.Text = "Add Datarow";
-      this.addRowButton.UseVisualStyleBackColor = true;
-      this.addRowButton.Click += new System.EventHandler(this.addRowButton_Click);
-      // 
-      // addColumnButton
-      // 
-      this.addColumnButton.Location = new System.Drawing.Point(338, 0);
-      this.addColumnButton.Name = "addColumnButton";
-      this.addColumnButton.Size = new System.Drawing.Size(83, 23);
-      this.addColumnButton.TabIndex = 10;
-      this.addColumnButton.Text = "Add Variable";
-      this.addColumnButton.UseVisualStyleBackColor = true;
-      this.addColumnButton.Click += new System.EventHandler(this.addColumnButton_Click);
-      // 
-      // renameColumnsButton
-      // 
-      this.renameColumnsButton.Location = new System.Drawing.Point(228, 26);
-      this.renameColumnsButton.Name = "renameColumnsButton";
-      this.renameColumnsButton.Size = new System.Drawing.Size(104, 23);
-      this.renameColumnsButton.TabIndex = 11;
-      this.renameColumnsButton.Text = "Rename Variables";
-      this.renameColumnsButton.UseVisualStyleBackColor = true;
-      this.renameColumnsButton.Click += new System.EventHandler(this.renameColumnsButton_Click);
-      // 
-      // showVariablesGroupBox
-      // 
-      this.showVariablesGroupBox.Controls.Add(this.checkInputsTargetButton);
-      this.showVariablesGroupBox.Controls.Add(this.uncheckAllButton);
-      this.showVariablesGroupBox.Controls.Add(this.checkAllButton);
-      this.showVariablesGroupBox.Location = new System.Drawing.Point(448, 0);
-      this.showVariablesGroupBox.Name = "showVariablesGroupBox";
-      this.showVariablesGroupBox.Size = new System.Drawing.Size(97, 49);
-      this.showVariablesGroupBox.TabIndex = 17;
-      this.showVariablesGroupBox.TabStop = false;
-      this.showVariablesGroupBox.Text = "Show Variables";
-      // 
       // DataGridContentView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.shuffleWithinPartitionsCheckBox);
+      this.Controls.Add(this.shuffleAllButton);
       this.Controls.Add(this.showVariablesGroupBox);
       this.Controls.Add(this.renameColumnsButton);
@@ -335,4 +352,6 @@
       this.Controls.SetChildIndex(this.columnsTextBox, 0);
       this.Controls.SetChildIndex(this.showVariablesGroupBox, 0);
+      this.Controls.SetChildIndex(this.shuffleAllButton, 0);
+      this.Controls.SetChildIndex(this.shuffleWithinPartitionsCheckBox, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.contextMenuCell.ResumeLayout(false);
@@ -361,5 +380,4 @@
     private System.Windows.Forms.Button btnReplace;
     private System.Windows.Forms.ToolTip toolTip;
-    private System.Windows.Forms.ToolStripMenuItem smoothingToolStripMenuItem_Column;
     private System.Windows.Forms.Button addRowButton;
     private System.Windows.Forms.Button addColumnButton;
@@ -369,4 +387,6 @@
     private System.Windows.Forms.Button uncheckAllButton;
     private System.Windows.Forms.Button checkAllButton;
+    private System.Windows.Forms.Button shuffleAllButton;
+    private System.Windows.Forms.CheckBox shuffleWithinPartitionsCheckBox;
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.cs	(revision 15535)
@@ -85,5 +85,5 @@
       base.RegisterContentEvents();
       Content.Changed += Content_Changed;
-      Content.FilterLogic.FilterChanged += FilterLogic_FilterChanged;
+      Content.PreprocessingData.FilterChanged += FilterLogic_FilterChanged;
     }
 
@@ -91,5 +91,5 @@
       base.DeregisterContentEvents();
       Content.Changed -= Content_Changed;
-      Content.FilterLogic.FilterChanged -= FilterLogic_FilterChanged;
+      Content.PreprocessingData.FilterChanged -= FilterLogic_FilterChanged;
     }
 
@@ -98,5 +98,5 @@
       searchIterator = null;
       if (findAndReplaceDialog != null && !findAndReplaceDialog.IsDisposed) {
-        if (Content.FilterLogic.IsFiltered) {
+        if (Content.PreprocessingData.IsFiltered) {
           findAndReplaceDialog.DisableReplace();
         } else {
@@ -104,5 +104,5 @@
         }
       }
-      btnReplace.Enabled = !Content.FilterLogic.IsFiltered;
+      btnReplace.Enabled = !Content.PreprocessingData.IsFiltered;
     }
 
@@ -126,5 +126,5 @@
       string errorMessage;
       if (!String.IsNullOrEmpty(e.FormattedValue.ToString())) {
-        if (dataGridView.IsCurrentCellInEditMode && Content.FilterLogic.IsFiltered) {
+        if (dataGridView.IsCurrentCellInEditMode && Content.PreprocessingData.IsFiltered) {
           errorMessage = "A filter is active, you cannot modify data. Press ESC to exit edit mode.";
         } else {
@@ -167,5 +167,5 @@
 
       ReplaceTransaction(() => {
-        Content.PreProcessingData.InTransaction(() => {
+        Content.PreprocessingData.InTransaction(() => {
           for (int row = containsHeader ? 1 : 0; row < values.GetLength(1); row++) {
             for (int col = 0; col < values.GetLength(0); col++) {
@@ -177,5 +177,5 @@
               if (string.IsNullOrWhiteSpace(firstRow[i]))
                 firstRow[i] = string.Format("<{0}>", i);
-            Content.PreProcessingData.RenameColumns(firstRow);
+            Content.PreprocessingData.RenameColumns(firstRow);
           }
         });
@@ -224,5 +224,5 @@
       if (e.Button == MouseButtons.Middle) {
         int newIndex = e.ColumnIndex >= 0 ? e.ColumnIndex : 0;
-        Content.PreProcessingData.InsertColumn<double>(newIndex.ToString(), newIndex);
+        Content.PreprocessingData.InsertColumn<double>(newIndex.ToString(), newIndex);
       } else if (e.Button == MouseButtons.Right && Content.SortableView) {
         SortColumn(e.ColumnIndex);
@@ -235,5 +235,5 @@
         if (e.Button == MouseButtons.Middle) {
           int newIndex = e.RowIndex >= 0 ? e.RowIndex : 0;
-          Content.PreProcessingData.InsertRow(newIndex);
+          Content.PreprocessingData.InsertRow(newIndex);
         }
       }
@@ -248,6 +248,6 @@
     }
 
-    private void btnApplySort_Click(object sender, System.EventArgs e) {
-      Content.ManipulationLogic.ReOrderToIndices(virtualRowIndices);
+    private void btnApplySort_Click(object sender, EventArgs e) {
+      Content.ReOrderToIndices(virtualRowIndices);
       OnContentChanged();
     }
@@ -271,5 +271,5 @@
         searchIterator = null;
         DataGridView.SelectionChanged += DataGridView_SelectionChanged_FindAndReplace;
-        if (Content.FilterLogic.IsFiltered) {
+        if (Content.PreprocessingData.IsFiltered) {
           findAndReplaceDialog.DisableReplace();
         }
@@ -405,8 +405,8 @@
       ComparisonOperation comparisonOperation = findAndReplaceDialog.GetComparisonOperation();
       var foundCells = new Dictionary<int, IList<int>>();
-      for (int i = 0; i < Content.FilterLogic.PreprocessingData.Columns; i++) {
+      for (int i = 0; i < Content.PreprocessingData.Columns; i++) {
         var filters = CreateFilters(match, comparisonOperation, i);
 
-        bool[] filteredRows = Content.FilterLogic.GetFilterResult(filters, true);
+        bool[] filteredRows = GetFilterResult(filters, true);
         var foundIndices = new List<int>();
         for (int idx = 0; idx < filteredRows.Length; ++idx) {
@@ -427,6 +427,23 @@
     }
 
+    private bool[] GetFilterResult(IList<IFilter> filters, bool isAndCombination) {
+      IList<IFilter> activeFilters = filters.Where(f => f.Active && f.ConstraintData != null).ToList();
+
+      if (activeFilters.Count == 0) {
+        return Enumerable.Repeat(false, Content.PreprocessingData.Rows).ToArray(); ;
+      }
+
+      var result = Enumerable.Repeat(!isAndCombination, Content.PreprocessingData.Rows).ToArray();
+      foreach (IFilter filter in activeFilters) {
+        bool[] filterResult = filter.Check();
+        for (int row = 0; row < result.Length; ++row) {
+          result[row] = isAndCombination ? result[row] || filterResult[row] : result[row] && filterResult[row];
+        }
+      }
+      return result;
+    }
+
     private List<IFilter> CreateFilters(string match, ComparisonOperation comparisonOperation, int columnIndex) {
-      IPreprocessingData preprocessingData = Content.FilterLogic.PreprocessingData;
+      IPreprocessingData preprocessingData = Content.PreprocessingData;
       IStringConvertibleValue value;
       if (preprocessingData.VariableHasType<double>(columnIndex)) {
@@ -473,20 +490,20 @@
           switch (findAndReplaceDialog.GetReplaceAction()) {
             case ReplaceAction.Value:
-              Content.ManipulationLogic.ReplaceIndicesByValue(cells, findAndReplaceDialog.GetReplaceText());
+              Content.ReplaceIndicesByString(cells, findAndReplaceDialog.GetReplaceText());
               break;
             case ReplaceAction.Average:
-              Content.ManipulationLogic.ReplaceIndicesByAverageValue(cells, false);
+              Content.ReplaceIndicesByMean(cells, false);
               break;
             case ReplaceAction.Median:
-              Content.ManipulationLogic.ReplaceIndicesByMedianValue(cells, false);
+              Content.ReplaceIndicesByMedianValue(cells, false);
               break;
             case ReplaceAction.Random:
-              Content.ManipulationLogic.ReplaceIndicesByRandomValue(cells, false);
+              Content.ReplaceIndicesByRandomValue(cells, false);
               break;
             case ReplaceAction.MostCommon:
-              Content.ManipulationLogic.ReplaceIndicesByMostCommonValue(cells, false);
+              Content.ReplaceIndicesByMode(cells, false);
               break;
             case ReplaceAction.Interpolation:
-              Content.ManipulationLogic.ReplaceIndicesByLinearInterpolationOfNeighbours(cells);
+              Content.ReplaceIndicesByLinearInterpolationOfNeighbours(cells);
               break;
           }
@@ -506,5 +523,4 @@
 
     #endregion FindAndReplaceDialog
-
     private void dataGridView_CellMouseClick(object sender, DataGridViewCellMouseEventArgs e) {
       if (Content == null) return;
@@ -531,10 +547,5 @@
             medianToolStripMenuItem_Selection.Enabled =
             randomToolStripMenuItem_Column.Enabled =
-            randomToolStripMenuItem_Selection.Enabled = !Content.PreProcessingData.AreAllStringColumns(columnIndices);
-
-          smoothingToolStripMenuItem_Column.Enabled =
-            interpolationToolStripMenuItem_Column.Enabled = !dataGridView.SelectedCells.Contains(dataGridView[e.ColumnIndex, 0])
-            && !dataGridView.SelectedCells.Contains(dataGridView[e.ColumnIndex, Content.Rows - 1])
-            && !Content.PreProcessingData.AreAllStringColumns(columnIndices);
+            randomToolStripMenuItem_Selection.Enabled = !Content.PreprocessingData.AreAllStringColumns(columnIndices);
 
           replaceValueOverColumnToolStripMenuItem.Visible = true;
@@ -547,5 +558,5 @@
       base.dataGridView_KeyDown(sender, e);
       //data is in read only mode....
-      if (Content.FilterLogic.IsFiltered) return;
+      if (Content.PreprocessingData.IsFiltered) return;
 
       if (e.KeyCode == Keys.Delete) {
@@ -581,8 +592,7 @@
       }
 
-      foreach (var selectedCell in dataGridView.SelectedCells) {
-        var cell = (DataGridViewCell)selectedCell;
+      foreach (DataGridViewCell cell in dataGridView.SelectedCells) {
         if (!selectedCells.ContainsKey(cell.ColumnIndex))
-          selectedCells.Add(cell.ColumnIndex, new List<int>(1024));
+          selectedCells.Add(cell.ColumnIndex, new List<int>());
         selectedCells[cell.ColumnIndex].Add(cell.RowIndex);
       }
@@ -591,16 +601,8 @@
     }
 
-    private void StartReplacing() {
+    private void ReplaceTransaction(Action action) {
       SuspendRepaint();
-    }
-
-    private void StopReplacing() {
+      action();
       ResumeRepaint(true);
-    }
-
-    private void ReplaceTransaction(Action action) {
-      StartReplacing();
-      action();
-      StopReplacing();
     }
 
@@ -616,13 +618,12 @@
 
     #region ContextMenu Events
-
     private void ReplaceWithAverage_Column_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByAverageValue(GetSelectedCells(), false);
+        Content.ReplaceIndicesByMean(GetSelectedCells(), false);
       });
     }
     private void ReplaceWithAverage_Selection_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByAverageValue(GetSelectedCells(), true);
+        Content.ReplaceIndicesByMean(GetSelectedCells(), true);
       });
     }
@@ -630,10 +631,10 @@
     private void ReplaceWithMedian_Column_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByMedianValue(GetSelectedCells(), false);
+        Content.ReplaceIndicesByMedianValue(GetSelectedCells(), false);
       });
     }
     private void ReplaceWithMedian_Selection_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByMedianValue(GetSelectedCells(), true);
+        Content.ReplaceIndicesByMedianValue(GetSelectedCells(), true);
       });
     }
@@ -641,10 +642,10 @@
     private void ReplaceWithRandom_Column_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByRandomValue(GetSelectedCells(), false);
+        Content.ReplaceIndicesByRandomValue(GetSelectedCells(), false);
       });
     }
     private void ReplaceWithRandom_Selection_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByRandomValue(GetSelectedCells(), true);
+        Content.ReplaceIndicesByRandomValue(GetSelectedCells(), true);
       });
     }
@@ -652,10 +653,10 @@
     private void ReplaceWithMostCommon_Column_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByMostCommonValue(GetSelectedCells(), false);
+        Content.ReplaceIndicesByMode(GetSelectedCells(), false);
       });
     }
     private void ReplaceWithMostCommon_Selection_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByMostCommonValue(GetSelectedCells(), true);
+        Content.ReplaceIndicesByMode(GetSelectedCells(), true);
       });
     }
@@ -663,11 +664,5 @@
     private void ReplaceWithInterpolation_Column_Click(object sender, EventArgs e) {
       ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesByLinearInterpolationOfNeighbours(GetSelectedCells());
-      });
-    }
-
-    private void ReplaceWithSmoothing_Selection_Click(object sender, EventArgs e) {
-      ReplaceTransaction(() => {
-        Content.ManipulationLogic.ReplaceIndicesBySmoothing(GetSelectedCells());
+        Content.ReplaceIndicesByLinearInterpolationOfNeighbours(GetSelectedCells());
       });
     }
@@ -675,9 +670,9 @@
 
     private void addRowButton_Click(object sender, EventArgs e) {
-      Content.PreProcessingData.InsertRow(Content.Rows);
+      Content.PreprocessingData.InsertRow(Content.Rows);
     }
 
     private void addColumnButton_Click(object sender, EventArgs e) {
-      Content.PreProcessingData.InsertColumn<double>(Content.Columns.ToString(), Content.Columns);
+      Content.PreprocessingData.InsertColumn<double>(Content.Columns.ToString(), Content.Columns);
     }
 
@@ -686,5 +681,5 @@
 
       if (renameDialog.ShowDialog(this) == DialogResult.OK) {
-        Content.PreProcessingData.RenameColumns(renameDialog.ColumnNames);
+        Content.PreprocessingData.RenameColumns(renameDialog.ColumnNames);
       }
     }
@@ -693,6 +688,6 @@
       foreach (DataGridViewColumn column in DataGridView.Columns) {
         var variable = column.HeaderText;
-        bool isInputTarget = Content.PreProcessingData.InputVariables.Contains(variable)
-          || Content.PreProcessingData.TargetVariable == variable;
+        bool isInputTarget = Content.PreprocessingData.InputVariables.Contains(variable)
+          || Content.PreprocessingData.TargetVariable == variable;
         column.Visible = isInputTarget;
       }
@@ -710,4 +705,8 @@
       }
     }
+
+    private void shuffleAllButton_Click(object sender, EventArgs e) {
+      Content.Shuffle(shuffleWithinPartitionsCheckBox.Checked);
+    }
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 15535)
@@ -49,12 +49,8 @@
       if (Content != null) {
         var data = Content.Data;
-        var filterLogic = new FilterLogic(data);
-        var searchLogic = new SearchLogic(data, filterLogic);
-        var statisticsLogic = new StatisticsLogic(data, searchLogic);
-        var manipulationLogic = new ManipulationLogic(data, searchLogic, statisticsLogic);
 
         var viewShortcuts = new ItemList<IViewShortcut> {
-          new DataGridContent(data, manipulationLogic, filterLogic),
-          new StatisticsContent(data, statisticsLogic),
+          new DataGridContent(data),
+          new StatisticsContent(data),
 
           new LineChartContent(data),
@@ -63,9 +59,9 @@
           new MultiScatterPlotContent(data),
           new CorrelationMatrixContent(Content),
-          new DataCompletenessChartContent(searchLogic),
-
-          new FilterContent(filterLogic),
-          new ManipulationContent(manipulationLogic, searchLogic, filterLogic),
-          new TransformationContent(data, filterLogic)
+          new DataCompletenessChartContent(data),
+
+          new FilterContent(data),
+          new ManipulationContent(data),
+          new TransformationContent(data)
         };
 
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs	(revision 15535)
@@ -46,5 +46,4 @@
     private void InitializeComponent() {
       this.groupBoxFilter = new System.Windows.Forms.GroupBox();
-      this.checkedFilterView = new HeuristicLab.DataPreprocessing.Views.CheckedFilterCollectionView();
       this.groupBoxFilterInfo = new System.Windows.Forms.GroupBox();
       this.lblPercentage = new System.Windows.Forms.Label();
@@ -63,4 +62,5 @@
       this.label3 = new System.Windows.Forms.Label();
       this.bottomPanel = new System.Windows.Forms.Panel();
+      this.checkedFilterView = new HeuristicLab.DataPreprocessing.Views.CheckedFilterCollectionView();
       this.groupBoxFilter.SuspendLayout();
       this.groupBoxFilterInfo.SuspendLayout();
@@ -80,16 +80,4 @@
       this.groupBoxFilter.TabStop = false;
       this.groupBoxFilter.Text = "Filter";
-      // 
-      // checkedFilterView
-      // 
-      this.checkedFilterView.Caption = "filterView";
-      this.checkedFilterView.Content = null;
-      this.checkedFilterView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.checkedFilterView.Location = new System.Drawing.Point(3, 16);
-      this.checkedFilterView.Name = "checkedFilterView";
-      this.checkedFilterView.ReadOnly = false;
-      this.checkedFilterView.ShowDetails = true;
-      this.checkedFilterView.Size = new System.Drawing.Size(652, 308);
-      this.checkedFilterView.TabIndex = 0;
       // 
       // groupBoxFilterInfo
@@ -185,5 +173,4 @@
       this.rBtnOr.AutoSize = true;
       this.rBtnOr.Cursor = System.Windows.Forms.Cursors.Default;
-      this.rBtnOr.Enabled = false;
       this.rBtnOr.Location = new System.Drawing.Point(53, 6);
       this.rBtnOr.Name = "rBtnOr";
@@ -199,5 +186,4 @@
       this.rBtnAnd.Checked = true;
       this.rBtnAnd.Cursor = System.Windows.Forms.Cursors.Default;
-      this.rBtnAnd.Enabled = false;
       this.rBtnAnd.Location = new System.Drawing.Point(3, 6);
       this.rBtnAnd.Name = "rBtnAnd";
@@ -273,4 +259,16 @@
       this.bottomPanel.Size = new System.Drawing.Size(670, 30);
       this.bottomPanel.TabIndex = 13;
+      // 
+      // checkedFilterView
+      // 
+      this.checkedFilterView.Caption = "filterView";
+      this.checkedFilterView.Content = null;
+      this.checkedFilterView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkedFilterView.Location = new System.Drawing.Point(3, 16);
+      this.checkedFilterView.Name = "checkedFilterView";
+      this.checkedFilterView.ReadOnly = false;
+      this.checkedFilterView.ShowDetails = true;
+      this.checkedFilterView.Size = new System.Drawing.Size(652, 308);
+      this.checkedFilterView.TabIndex = 0;
       // 
       // FilterView
